#include <windows.h>
#include "unzip.h"

struct tagResFile
{
	BYTE *data;
	long size;
	long offs;
};

static voidpf open(voidpf opaque, const char *fname, int mode)
{
	HRSRC rsrc;
	struct tagResFile *fp;

	if(!(rsrc = FindResource(GetModuleHandle(NULL), fname, "ZIP")))
		return NULL;

	if(!(fp = malloc(sizeof(*fp))))
		return NULL;

	fp->data = LockResource(LoadResource(GetModuleHandle(NULL), rsrc));
	fp->size = SizeofResource(GetModuleHandle(NULL), rsrc);
	fp->offs = 0;

	if(!fp->data)
	{
		free(fp);
		return NULL;
	}

	return fp;
}
static uLong read(voidpf opaque, voidpf stream, void* buf, uLong size)
{
	struct tagResFile *fp = stream;

	if(fp->offs + (long)size > fp->size)
		size = fp->size - fp->offs;

	memcpy(buf, fp->data + fp->offs, size);

	fp->offs += size;

	return size;
}
static uLong write(voidpf opaque, voidpf stream, const void* buf, uLong size)
{
	MessageBox(NULL, "write not supported", "Fatal: ffres: write", MB_OK);
	return 0;
}
static long tell(voidpf opaque, voidpf stream)
{
	struct tagResFile *fp = stream;

	return fp->offs;
}
static long seek(voidpf opaque, voidpf stream, uLong offset, int origin)
{
	struct tagResFile *fp = stream;

	switch(origin)
	{
	case SEEK_SET:	fp->offs = offset;	break;
	case SEEK_CUR:	fp->offs += offset;	break;
	case SEEK_END:	fp->offs = fp->size;	break;
	}

	return 0;	// succeed
}
static int close(voidpf opaque, voidpf stream)
{
	struct tagResFile *fp = stream;

	free(fp);

	return 0;
}
static int testerror(voidpf opaque, voidpf stream)
{
	return 0;
}

static zlib_filefunc_def ffdef = {
	open,
	read,
	write,
	tell,
	seek,
	close,
	testerror,
	NULL
};

zlib_filefunc_def *getResFileFuncDef(void)
{
	return &ffdef;
}
