#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include <windows.h>
#include <GL/gl.h>
#define GL_CLAMP_TO_EDGE 0x812F
#include <GL/glu.h>
#include <GL/glpngx.h>
#include <SDL_mixer.h>
#include <time.h>

#include "unzip.h"
#include "ffres.h"
#include "objload.h"


// #define ZIPFS
// #define ZIPRESOURCE


#ifndef M_PI	// why not in VC++6??
#define M_PI 3.1415926f
#endif

#define rnd(f) ((float)rand() / (float)RAND_MAX * (float)(f))
#define clamp(f,a,b) ((f) < (a) ? (a) : (b) < (f) ? (b) : (f))
//#define max(f,a) ((f) < (a) ? (a) : (f))



//GLboolean rot = GL_TRUE, rott = GL_FALSE;

int WinW, WinH, isFullscr;

unsigned char kcurstate[SDLK_LAST] = {0};	// key state
unsigned char kstate[SDLK_LAST] = {0};
int kcurmod = 0;	// modifier keys
int kmod = 0;
#define MOUSE_BUTTONS 8
unsigned char mcurstate[MOUSE_BUTTONS] = {0};	// mouse state
unsigned char mstate[MOUSE_BUTTONS] = {0};
float mx, my, dmx, dmy;	// mouse x,y(delta x,y)
float sx,sy;

Mix_Music *bgm1;
Mix_Chunk *sndshot, *sndengines[3], *sndmissile, *sndlockon, *sndbomb;
float preshot;

OBJECT *objf15, *objmig25, *objf14, *objmissile, *objbullet;
GLuint texjet, texsea, texjetf, texjetf2, texsky, texlock1, texlock2, texlock3, texsight, texlandmap;
GLuint texsplash, texsplashw1, texsplashw2, texsmoke, texsun, texbsmoke, texburn, texabshock, texhud;
GLuint textitle, texendseq;
int engine_ch, curengine;
float buruburu = 0.0f;
float boosttime = 0;
int boosted = 0;

int rside = -1;

int prefps, curfps, fpssec;
float framedelta;
float begintime;

int stockedmissiles;
float lastshoot;
int score;
int gameset;
int titling = 1;
float gamesettime;

#define TERRAS	4
#define TERRAW	16
#define TERRAZ	8
float land[TERRAS][TERRAW+1][TERRAW+1];

/* ]p */
//static float angle = 0.0f, anglet = 0.0f, angleu = 0.0f;

#define MAXLOCKON 32

#define REAL float
struct tagFlies
{
	REAL pos[3];	// position
	//float prepos[3];	// preframe-position
	REAL vel[3];	// velocity
	REAL acc[3];	// acceleration
	REAL rot[3];	// pitch,yaw,roll (deg)

	OBJECT *obj;	// object model

	enum{
		TYPE_FIGHTER,
		TYPE_MISSILE,
		TYPE_BULLET,
		TYPE_TERRAIN,
		TYPE_SPLASH,
		TYPE_SMOKE,
		TYPE_BOMBFLASH,
		TYPE_BOMBSTUFF,
		TYPE_BOMBSMOKE,
		TYPE_ABSHOCK,
	}type;			// type
	enum{
		OWN_NONE,
		OWN_SELF,
		OWN_ENEMY,
	}owner;			// owner type
	struct tagFlies *target;	// missile target
	int toffs;	// for terrain
	float borntime;	// born time
	REAL userf;	// for user
	REAL userf2;
	int targetfired;	// missile targetted fired
	float firemissilez;	// time to fire missile
	float orgz;	// for enemy fighter fireing missile: original-z
	int firedmissile;	// enemy fighter: fired?

	float lifespan;	// same as UnrealEngine's actor's

	struct tagFlies *next;	// next fly
} flyPlayer, *flyRoot = &flyPlayer, *flyLocked[MAXLOCKON] = {NULL};

struct tagEnemies{
	float zpoint;
	float pos[3];
	float vel[3];
	float acc[3];
	enum{
		FIGHTER_F14=1,
		FIGHTER_F15,
		FIGHTER_MIG25,
	}ftype;
	float firemissilez;

	struct tagEnemies *next;
} *eneRoot[10] = {NULL}, *eneCurr;




float gettime(void)
{
	return SDL_GetTicks() / 1000.0f;
}

// simulate
void APIENTRY glMaterialubv (GLenum face, GLenum pname, const GLubyte *params)
{
	GLfloat ip[4] = {params[0]/256.0f, params[1]/256.0f, params[2]/256.0f, 1.0f};
	glMaterialfv(face, pname, ip);
}

void drawobj(OBJECT* obj, int pass, float fsize, float vsize, float haloa)
{
	int i, j;

	glPushAttrib(GL_ALL_ATTRIB_BITS);

	for(i = 0; i < obj->cobjs; i++)
	{
		if(!strncmp(obj->objs[i].name, "jet.", 4))
		{
			if(pass==1)
				continue;

			glEnable(GL_TEXTURE_2D);
			glDisable(GL_CULL_FACE);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE);
			//glTexEnvi(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATE);
			glDepthMask(GL_FALSE);
			glDisable(GL_LIGHTING);

			glPushMatrix();
			glPushAttrib(GL_CURRENT_BIT);
			
			glTranslatef(obj->objs[i].vtxs[0][0], obj->objs[i].vtxs[0][1], obj->objs[i].vtxs[0][2]);

			// jet-light
			glNewList(1, GL_COMPILE);
			glBegin(GL_QUADS);
			glTexCoord2f(0, 0);		glVertex3f(-1,  1, 0);
			glTexCoord2f(0, 1);		glVertex3f(-1, -1, 0);
			glTexCoord2f(1, 1);		glVertex3f( 1, -1, 0);
			glTexCoord2f(1, 0);		glVertex3f( 1,  1, 0);
			glEnd();
			glEndList();

			glPushMatrix();
			glScalef(fsize * 2.33f, fsize * 2.33f, fsize * 2.33f);
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f * haloa);
			glBindTexture(GL_TEXTURE_2D, texjetf);
			glCallList(1);
			glScalef(2,2,2);
			glColor4f(1.0f, 1.0f, 1.0f, rnd(0.2f) * haloa);
			glBindTexture(GL_TEXTURE_2D, texjetf2);
			glCallList(1);
			glDeleteLists(1, 1);
			glPopMatrix();

			// jet-fire
			glBindTexture(GL_TEXTURE_2D, texjet);
			//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
			glPushMatrix();
			glScalef(fsize, fsize, vsize);
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			{
				float i, s, step;

				s = (float)fmod(gettime() * 2.0f, 1.0f);

				glBegin(GL_QUADS);
				step = M_PI * 2.0f / 12.f;
				for(i = 0.0f; i < M_PI * 2.0f; i += step)
				{
					glTexCoord2f(s, 0);	glVertex3f((float)cos(i     ), (float)sin(i     ), 0);
					glTexCoord2f(s, 0);	glVertex3f((float)cos(i+step), (float)sin(i+step), 0);
					glTexCoord2f(s, 1);	glVertex3f((float)cos(i+step), (float)sin(i+step), 1);
					glTexCoord2f(s, 1);	glVertex3f((float)cos(i     ), (float)sin(i     ), 1);
				}
				glEnd();
			}
			glPopMatrix();

			glPopAttrib();
			glPopMatrix();

			continue;
		}else
		{
			if(pass==2)
				continue;
			glDisable(GL_TEXTURE_2D);
			glEnable(GL_CULL_FACE);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glEnable(GL_LIGHTING);
			glDepthMask(GL_TRUE);
		}
		for(j = 0; j < obj->objs[i].ctris; j++)
		{
			glMaterialubv(GL_FRONT, GL_AMBIENT, obj->mats[obj->objs[i].tmat[j]].amb);
			glMaterialubv(GL_FRONT, GL_DIFFUSE, obj->mats[obj->objs[i].tmat[j]].dif);
			glMaterialubv(GL_FRONT, GL_SPECULAR, obj->mats[obj->objs[i].tmat[j]].spe);
			glMaterialf(GL_FRONT, GL_SHININESS, 32.0);

			glNormal3fv(obj->objs[i].tnor[j]);

			glBegin(GL_TRIANGLES);
			//if(obj->objs[i].vuvs && obj->objs[i].vuvs[obj->objs[i].tris[j][0]])
			//	glTexCoord2f(s, 1-obj->objs[i].vuvs[obj->objs[i].tris[j][0]][1]);
			//glNormal3fv(obj->objs[i].vnor[obj->objs[i].tris[j][0]]);
			glVertex3fv(obj->objs[i].vtxs[obj->objs[i].tris[j][0]]);
			//if(obj->objs[i].vuvs && obj->objs[i].vuvs[obj->objs[i].tris[j][1]])
			//	glTexCoord2f(s, 1-obj->objs[i].vuvs[obj->objs[i].tris[j][1]][1]);
			//glNormal3fv(obj->objs[i].vnor[obj->objs[i].tris[j][1]]);
			glVertex3fv(obj->objs[i].vtxs[obj->objs[i].tris[j][1]]);
			//if(obj->objs[i].vuvs && obj->objs[i].vuvs[obj->objs[i].tris[j][2]])
			//	glTexCoord2f(s, 1-obj->objs[i].vuvs[obj->objs[i].tris[j][2]][1]);
			//glNormal3fv(obj->objs[i].vnor[obj->objs[i].tris[j][2]]);
			glVertex3fv(obj->objs[i].vtxs[obj->objs[i].tris[j][2]]);
			glEnd();
		}
	}
	
	glPopAttrib();
}

void getAxis(REAL *r, REAL *x, REAL *y, REAL *z)
{
	if(!r)
		return;

	if(z)
	{
		z[0] =  (REAL)(cos( r[0]    /180*M_PI) * sin(r[1]/180*M_PI));
		z[1] = -(REAL)(sin( r[0]    /180*M_PI)                     );
		z[2] =  (REAL)(cos( r[0]    /180*M_PI) * cos(r[1]/180*M_PI));
	}

	if(y)
	{
		y[0] =  (REAL)(cos((r[0]-90)/180*M_PI) * sin(r[1]/180*M_PI));
		y[1] = -(REAL)(sin((r[0]-90)/180*M_PI)                     );
		y[2] =  (REAL)(cos((r[0]-90)/180*M_PI) * cos(r[1]/180*M_PI));
	}

	// x not supported.

	return;
}

void getRot(REAL *v, REAL *r)
{
	if(!v || !r)
		return;

	r[0] = -((REAL)atan2(sqrt(v[0]*v[0] + v[2]*v[2]), v[1])/M_PI*180 - 90);
	r[1] = -(REAL)atan2(v[0], -v[2])/M_PI*180;
	r[2] = (REAL)sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);

	return;
}

REAL norm(REAL *v)
{
	return (REAL)sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
}

void normalize(REAL *v)
{
	REAL n;

	if(!v)
		return;

	n = norm(v);
	v[0] /= n;
	v[1] /= n;
	v[2] /= n;
}

REAL distance(REAL *v1, REAL *v2)
{
	return (REAL)sqrt(
		(v1[0]-v2[0])*(v1[0]-v2[0]) + 
		(v1[1]-v2[1])*(v1[1]-v2[1]) + 
		(v1[2]-v2[2])*(v1[2]-v2[2])
		);
}

void draw()
{
	float ti = gettime();
	REAL a, ssx, ssy;

    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glEnable(GL_DEPTH_TEST);

	if(titling)
		goto skipgamedraw;

	{
		float c[4] = {0.8f, 0.8f, 0.8f, 1.0f};

		glFogi(GL_FOG_MODE, GL_LINEAR);
		glFogf(GL_FOG_START, 800);
		glFogf(GL_FOG_END, 900);
		glFogfv(GL_FOG_COLOR, c);
	}

    glLoadIdentity( );

	gluPerspective(40, (float)WinW/WinH, 1.0, 5000.0);

	if(sy >= 0)
		ssx = sx, ssy = sy;
	else
		ssx = -sx, ssy = -sy;
	a = -flyPlayer.rot[2] / 180.0f * M_PI;//(float)atan2(ssx, ssy) * (float)sqrt(ssx*ssx+ssy*ssy);

	//gluLookAt(rnd(.02)-.01f, rnd(.02)-.01f, 0, 0, 0, -1, 0, 1, 0);
	{
		REAL z[3], y[3], v1[3], v2[3], r[3], r1[3];
		static REAL pr[3];

		r[0] = flyPlayer.rot[0]/2;
		r[1] = flyPlayer.rot[1]/2;
		r[2] = flyPlayer.rot[2]/2;

		getAxis(r, NULL, y, z);

		r1[0] = flyPlayer.pos[0] + y[0] * 1.3f + z[0] * 7.0f;
		r1[1] = flyPlayer.pos[1] + y[1] * 1.3f + z[1] * 7.0f;
		r1[2] = /*flyPlayer.pos[2] +*/ y[2] * 1.3f + z[2] * 7.0f;

		v1[0] = (r1[0]+pr[0])/2;
		v1[1] = (r1[1]+pr[1])/2;
		v1[2] = (r1[2]+pr[2])/2;

		pr[0] = r1[0];
		pr[1] = r1[1];
		pr[2] = r1[2];

		v2[0] = v1[0] + z[0] * -1.0f;
		v2[1] = v1[1] + z[1] * -1.0f;
		v2[2] = v1[2] + z[2] * -1.0f;
		
		gluLookAt(v1[0] + rnd(buruburu), v1[1] + rnd(buruburu), v1[2] + rnd(buruburu), v2[0], v2[1], v2[2], sin(a), cos(a), 0);
	}

	buruburu = clamp(buruburu - 0.00025f, 0, 1);

	glEnable(GL_FOG);
	glPushMatrix();
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);

	glTranslatef(flyPlayer.pos[0],0,/*flyPlayer.pos[2]*/0);

	glScalef(500,1000,1000);

	// sky
	glDisable(GL_FOG);
	glBindTexture(GL_TEXTURE_2D, texsky);
	glBegin(GL_QUADS);
	// sky-front
	glTexCoord2f(.60f,0);	glVertex3f( 2, 1, -1);
	glTexCoord2f(.15f,0);	glVertex3f(-2, 1, -1);
	glTexCoord2f(.15f,1);	glVertex3f(-2, 0, -1);
	glTexCoord2f(.60f,1);	glVertex3f( 2, 0, -1);
	// sky-ceil
	glTexCoord2f(.60f,0);	glVertex3f( 2, 1, .1f);
	glTexCoord2f(.15f,0);	glVertex3f(-2, 1, .1f);
	glTexCoord2f(.15f,0);	glVertex3f(-2, 1, -1);
	glTexCoord2f(.60f,0);	glVertex3f( 2, 1, -1);
	// sky-left
	glTexCoord2f(.15f,0);	glVertex3f(-2, 1, -1);
	glTexCoord2f(.0f ,0);	glVertex3f(-2, 1, .1f);
	glTexCoord2f(.0f ,1);	glVertex3f(-2, 0, .1f);
	glTexCoord2f(.15f,1);	glVertex3f(-2, 0, -1);
	// sky-right
	glTexCoord2f(.75f,0);	glVertex3f( 2, 1, .1f);
	glTexCoord2f(.60f,0);	glVertex3f( 2, 1, -1);
	glTexCoord2f(.60f,1);	glVertex3f( 2, 0, -1);
	glTexCoord2f(.75f,1);	glVertex3f( 2, 0, .1f);
	glEnd();
	// sea
	glEnable(GL_FOG);
	glBindTexture(GL_TEXTURE_2D, texsea);
	{
		REAL s = ti * -flyPlayer.vel[2];
		glBegin(GL_QUADS);
		glTexCoord2f(80+flyPlayer.pos[0]*.1f,-50-s);	glVertex3f( 2, 0, -1);
		glTexCoord2f(0 +flyPlayer.pos[0]*.1f,-50-s);	glVertex3f(-2, 0, -1);
		glTexCoord2f(0 +flyPlayer.pos[0]*.1f,  5-s);	glVertex3f(-2, 0, .1f);
		glTexCoord2f(80+flyPlayer.pos[0]*.1f,  5-s);	glVertex3f( 2, 0, .1f);
		glEnd();
	}

	glPopAttrib();
	glDisable(GL_LIGHTING);
	glPushMatrix();
	glTranslatef(-.8f, .5f, -.8f);
	{
		float pos[4] = {0.0, 0.0, 0.0, 1.0};
		float white[4] = {1.0, 1.0, 1.0, 1.0};

		glLightfv(GL_LIGHT0, GL_AMBIENT, white);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
		glLightfv(GL_LIGHT0, GL_SPECULAR, white);
		glLightfv(GL_LIGHT0, GL_POSITION, pos);
	}
	/*
	{
		GLUquadric *q = gluNewQuadric();
		gluQuadricDrawStyle(q, GLU_LINE);
		gluSphere(q, .01, 8, 8);
		gluDeleteQuadric(q);
	}
	*/
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glScalef(2, 1, 1);
	glRotatef(45, 1, 0, 1);
	glScalef(.4f, .4f, .4f);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glBindTexture(GL_TEXTURE_2D, texsun);
	glBegin(GL_QUADS);
	glTexCoord2f(1, 0);	glVertex3f( 1, 1, 0);
	glTexCoord2f(0, 0);	glVertex3f(-1, 1, 0);
	glTexCoord2f(0, 1);	glVertex3f(-1,-1, 0);
	glTexCoord2f(1, 1);	glVertex3f( 1,-1, 0);
	glEnd();
	glPopAttrib();
	glPopMatrix();


	glPopMatrix();
	//glPopAttrib();

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	//	oldlight
	/*
	glPushMatrix();
	glTranslatef( flyPlayer.pos[0], flyPlayer.pos[1], /*flyPlayer.pos[2]* /0);
	glTranslatef(0, 1, 0);
	glPopMatrix();
	*/

	//glRotatef( a/3.14159f*180.0f, 0, 0, -1);

	{
		struct tagFlies *fly;
		int fir = 1;

		for(fly = flyRoot; fly; fly = fly->next)
		{
			glPushMatrix();
			if(fly == &flyPlayer)
				glTranslatef(fly->pos[0], fly->pos[1], 0);
			else
				glTranslatef(fly->pos[0], fly->pos[1], fly->pos[2] - (flyPlayer.pos[2]));
			/*
			if(fly->type == TYPE_SMOKE && fir)
			{
				char ts[256];
				fir = 0;
				sprintf(ts, "%f %f %f\n", fly->pos[2] - (flyPlayer.pos[2]), fly->pos[2], flyPlayer.pos[2]);
				OutputDebugString(ts);
			}
			*/
			/*
			if(fly->type == TYPE_TERRAIN)
			{
				char ts[256];
				sprintf(ts, "%.2f %.2f %.2f\n", fly->pos[2], flyPlayer.pos[2], fly->pos[2] - (flyPlayer.pos[2]));
				OutputDebugString(ts);
			}
			*/
			glRotatef(fly->rot[1], 0.0f, 1.0f, 0.0f);
			glRotatef(fly->rot[0], 1.0f, 0.0f, 0.0f);
			glRotatef(fly->rot[2], 0.0f, 0.0f, 1.0f);
			/*
			if(fly == &flyPlayer)
			{
				char ts[256];
				float r[3];
				glBegin(GL_LINES);
				glVertex3f(0, 0 ,0);
				glVertex3fv(fly->vel);
				glEnd();
				getRot(fly->vel, r);
				sprintf(ts, "%f %f %f->%f %f %f\n",fly->vel[0],fly->vel[1],fly->vel[2],r[0],r[1],r[2]);
				OutputDebugString(ts);
			}
			*/
			if(fly->obj)
			{
				float size = 1.0f;
				float power = 0.5f;

				if(fly->type == TYPE_MISSILE)
					size = .5f;

				if(fly == &flyPlayer)
					power = fly->userf;

				drawobj(fly->obj,1, .15f*size*power, 3.0f*size*power, power);
				drawobj(fly->obj,2, .15f*size*power, 3.0f*size*power, power);
			}
			if(fly->type == TYPE_TERRAIN && fly->pos[2] - (flyPlayer.pos[2]) > -1500 - TERRAW/2*TERRAZ)
			{
				int x, y, o;
				static float r = 0;
				float gf[][4] = {
					{0, 0, 0, 0},
					{0, -1, 0, 0},
				};

				glPushMatrix();
				glPushAttrib(GL_ALL_ATTRIB_BITS);
				//glTranslatef(0, 2, -12.8f - 5);
				glScalef(TERRAZ, 10.0f, -TERRAZ);
				glTranslatef(0, -.2f, 0);
				r+=M_PI * 2 / 60.0f / 10.0f;
				//glTranslatef(0,(float)sin(r)*3,0);
				//glRotatef(r/3.14159f*180,0,1,0);
				//glRotatef(r/3.14f*180, 1,0,0);
				glTranslatef(-TERRAW/2, 0, -TERRAW/2);
				glDisable(GL_LIGHTING);
				//glEnable(GL_LIGHTING);
				//glEnable(GL_BLEND);
				//glDepthMask(GL_FALSE);
				glDisable(GL_CULL_FACE);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				glColor4f(1.0f,1.0f,1.0f, 1.0f);
				glEnable(GL_TEXTURE_2D);
				glBindTexture(GL_TEXTURE_2D, texlandmap);
				glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
				glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
				glTexGenfv(GL_S, GL_OBJECT_PLANE, gf[0]);
				glTexGenfv(GL_T, GL_OBJECT_PLANE, gf[1]);
				glEnable(GL_TEXTURE_GEN_S);
				glEnable(GL_TEXTURE_GEN_T);
				o = (int)fly->toffs;
				glBegin(GL_QUADS);
				glNormal3f(0, 1, 0);
				for(y = 0; y < TERRAW; y++)
				{
					for(x = 0; x < TERRAW; x++)
					{
						glVertex3f((float)x  , land[o][x  ][y+1], (float)y+1);
						glVertex3f((float)x  , land[o][x  ][y  ], (float)y  );
						glVertex3f((float)x+1, land[o][x+1][y  ], (float)y  );
						glVertex3f((float)x+1, land[o][x+1][y+1], (float)y+1);
					}
				}
				glEnd();
				glPopAttrib();
				glPopMatrix();
			}
			if(fly->type == TYPE_SMOKE || fly->type == TYPE_BOMBFLASH || fly->type == TYPE_BOMBSMOKE || fly->type == TYPE_ABSHOCK)
			{
				glPushMatrix();
				glPushAttrib(GL_ALL_ATTRIB_BITS);

				glDisable(GL_LIGHTING);
				glDisable(GL_CULL_FACE);
				glEnable(GL_TEXTURE_2D);
				glEnable(GL_BLEND);

				switch(fly->type)
				{
				case TYPE_SMOKE:
					glColor4f(1.0f, 1.0f, 1.0f, 1.0f - (ti - fly->borntime));
					glBindTexture(GL_TEXTURE_2D, texsmoke);
					glScalef(0.5f, 0.5f, 0.5f);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
					break;
				case TYPE_BOMBFLASH:
					glColor4f(1.0f, 1.0f, 1.0f, 1.0f - (ti - fly->borntime));
					glBindTexture(GL_TEXTURE_2D, texburn);
					glScalef(15.f, 15.f, 15.f);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE);
					break;
				case TYPE_BOMBSTUFF:
					/*
					glColor4f(1.0f, 1.0f, 1.0f, clamp(2.0f - (ti - fly->borntime),0,1));
					glBindTexture(GL_TEXTURE_2D, texbsmoke);
					glScalef(fly->userf, fly->userf, fly->userf);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
					*/
					glColor4f(0,0,0,0);
					break;
				case TYPE_BOMBSMOKE:
					glColor4f(1.0f, 1.0f, 1.0f, clamp(2.0f - (ti - fly->borntime),0,1));
					glBindTexture(GL_TEXTURE_2D, texbsmoke);
					glScalef(fly->userf, fly->userf, fly->userf);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
					break;
				case TYPE_ABSHOCK:
					glColor4f(1.0f, 1.0f, 1.0f, (.3f - (ti - fly->borntime))/.3f);
					glBindTexture(GL_TEXTURE_2D, texabshock);
					glScalef(3.f, 3.f, 3.f);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE);
					break;
				}

				glDepthMask(GL_FALSE);
				glBegin(GL_QUADS);
				glTexCoord2f(1, 0);	glVertex3f( 1,  1, 0);
				glTexCoord2f(0, 0);	glVertex3f(-1,  1, 0);
				glTexCoord2f(0, 1);	glVertex3f(-1, -1, 0);
				glTexCoord2f(1, 1);	glVertex3f( 1, -1, 0);
				glEnd();

				glPopAttrib();
				glPopMatrix();
			}
			glPopMatrix();
		}
	}

	/*
	// this fog is bad look...
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glPushMatrix();
	glTranslatef(0, 0, -500);
	glScalef(250, 25.0f, 5.0f);
	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glDisable(GL_FOG);
	glDisable(GL_LIGHTING);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(0.8f, 0.8f, 0.8f, 0.1f);

	{
		float i;

		glBegin(GL_QUADS);
		for(i = 0; i < 15; i++)
		{
			glVertex3f( 2, 1, i);
			glVertex3f(-2, 1, i);
			glVertex3f(-2, 0, i);
			glVertex3f( 2, 0, i);
		}
		glEnd();
	}
	glPopMatrix();
	glPopAttrib();
	*/
skipgamedraw:

	// 2D stuff
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1,1,1,1);

	if(titling)
		goto skipgamehud;

	{
		REAL z[3];
		double wx,wy,wz;
		double model[16],proj[16];
		int view[4];

		getAxis(flyPlayer.rot, NULL, NULL, z);

		glGetDoublev(GL_MODELVIEW_MATRIX, model);
		glGetDoublev(GL_PROJECTION_MATRIX, proj);
		glGetIntegerv(GL_VIEWPORT, view);

		gluProject(z[0]*100 + flyPlayer.pos[0],z[1]*100 + flyPlayer.pos[1],z[2]*100 /*+ flyPlayer.pos[2]*/, model, proj, view, &wx, &wy, &wz);

		glPushMatrix();
		glLoadIdentity();
		glTranslated((wx*2-WinW)/WinW, (wy*2-WinH)/WinH, 0);
		glBindTexture(GL_TEXTURE_2D, texsight);
		glScalef(0.05f, 0.05f, 1);
		glBegin(GL_QUADS);
		glTexCoord2f(1, 0);	glVertex2f( 1,  1);
		glTexCoord2f(0, 0);	glVertex2f(-1,  1);
		glTexCoord2f(0, 1);	glVertex2f(-1, -1);
		glTexCoord2f(1, 1);	glVertex2f( 1, -1);
		glEnd();
		glPopMatrix();

		// lockon! // TODO: DO HERE?
		{
			struct tagFlies *fly;
			double ux,uy,uz;
			wx = (wx*2-WinW)/WinW;
			wy = (wy*2-WinH)/WinH;
			for(fly = flyRoot; fly; fly = fly->next)
			{
				if(fly->type == TYPE_FIGHTER && fly->owner == OWN_ENEMY)
				{
					gluProject(fly->pos[0],fly->pos[1],fly->pos[2] - flyPlayer.pos[2], model, proj, view, &ux, &uy, &uz);
					ux = (ux*2-WinW)/WinW;
					uy = (uy*2-WinH)/WinH;
					if(wx-.028<ux&&wy-.028<uy&&ux<wx+.028&&uy<wy+.028 && fly->pos[2] - flyPlayer.pos[2] < 0)
					{
						int i;
						for(i = 0; i < MAXLOCKON; i++)
						{
							if(flyLocked[i] == fly)
								break;
						}
						if(i == MAXLOCKON)
						{
							for(i = 0; i < MAXLOCKON; i++)
							{
								if(!flyLocked[i])
								{
									flyLocked[i] = fly;
									Mix_PlayChannel(-1, sndlockon, 0);
									break;
								}
							}
						}
					}
				}
			}
		}

		{
			int i;
			for(i = 0; i < MAXLOCKON; i++)
			{
				if(flyLocked[i] && flyLocked[i]->pos[2] - flyPlayer.pos[2] < 0)
				{
					z[0] = flyLocked[i]->pos[0];
					z[1] = flyLocked[i]->pos[1];
					z[2] = flyLocked[i]->pos[2];
					gluProject(z[0],z[1],z[2] - flyPlayer.pos[2], model, proj, view, &wx, &wy, &wz);
					glPushMatrix();
						glLoadIdentity();
						glTranslated((wx*2-WinW)/WinW, (wy*2-WinH)/WinH, 0);
						glScalef(0.025f, 0.025f, 1);
						glBindTexture(GL_TEXTURE_2D, texlock1);
						glBegin(GL_QUADS);
						glTexCoord2f(1, 0);	glVertex2f( 1,  1);
						glTexCoord2f(0, 0);	glVertex2f(-1,  1);
						glTexCoord2f(0, 1);	glVertex2f(-1, -1);
						glTexCoord2f(1, 1);	glVertex2f( 1, -1);
						glEnd();
						glPushMatrix();
							{
								float s=(1-(float)fmod(ti*3,1))*2;
								glScalef(2+s,2+s,2+s);
							}
							glBindTexture(GL_TEXTURE_2D, texlock2);
							glBegin(GL_QUADS);
							glTexCoord2f(1, 0);	glVertex2f( 1,  1);
							glTexCoord2f(0, 0);	glVertex2f(-1,  1);
							glTexCoord2f(0, 1);	glVertex2f(-1, -1);
							glTexCoord2f(1, 1);	glVertex2f( 1, -1);
							glEnd();
						glPopMatrix();
						if(flyLocked[i]->targetfired)
						{
							glScalef(0.5f, 0.5f, 1);
							glBindTexture(GL_TEXTURE_2D, texlock3);
							glBegin(GL_QUADS);
							glTexCoord2f(1, 0);	glVertex2f( 1,  1);
							glTexCoord2f(0, 0);	glVertex2f(-1,  1);
							glTexCoord2f(0, 1);	glVertex2f(-1, -1);
							glTexCoord2f(1, 1);	glVertex2f( 1, -1);
							glEnd();
						}
					glPopMatrix();
				}
			}
		}

	}

	// HUD
	glLoadIdentity();
	glBindTexture(GL_TEXTURE_2D, texhud);

	// speed
	{
		float r = rnd(0.025f);

		glPushMatrix();
			glTranslatef(-.97f, -.97f, 0);
			glScalef(0.8f, 0.15f, 1);
			glBegin(GL_QUADS);
			glTexCoord2f(flyPlayer.userf+r, 1./8);	glVertex2f( flyPlayer.userf+r, 1);
			glTexCoord2f(0, 1./8);					glVertex2f( 0, 1);
			glTexCoord2f(0, 1./8*2);					glVertex2f( 0, 0);
			glTexCoord2f(flyPlayer.userf+r, 1./8*2);	glVertex2f( flyPlayer.userf+r, 0);

			glTexCoord2f(1,    0);	glVertex2f( 1, 1);
			glTexCoord2f(0,    0);	glVertex2f( 0, 1);
			glTexCoord2f(0, 1./8);	glVertex2f( 0, 0);
			glTexCoord2f(1, 1./8);	glVertex2f( 1, 0);
			glEnd();
		glPopMatrix();
	}

	// missiles
	glPushMatrix();
		glTranslatef(-.97f, -.77f, 0);
		glScalef(0.1f, 0.2f, 1);
		{
			int i = stockedmissiles;

			for(; i >= 10; i -= 10)
			{
				glBegin(GL_QUADS);
				glTexCoord2f(1./8*1, 1./8*3);	glVertex2f( 1, 1);
				glTexCoord2f(1./8*0, 1./8*3);	glVertex2f( 0, 1);
				glTexCoord2f(1./8*0, 1./8*5);	glVertex2f( 0, 0);
				glTexCoord2f(1./8*1, 1./8*5);	glVertex2f( 1, 0);
				glEnd();
				glTranslatef(.5f, 0, 0);
			}
			for(; i > 0; i--)
			{
				glBegin(GL_QUADS);
				glTexCoord2f(1./8*2, 1./8*3);	glVertex2f( 1, 1);
				glTexCoord2f(1./8*1, 1./8*3);	glVertex2f( 0, 1);
				glTexCoord2f(1./8*1, 1./8*5);	glVertex2f( 0, 0);
				glTexCoord2f(1./8*2, 1./8*5);	glVertex2f( 1, 0);
				glEnd();
				glTranslatef(.4f, 0, 0);
			}
		}
	glPopMatrix();

	if(gameset)
	{
		glPushAttrib(GL_CURRENT_BIT | GL_TEXTURE_BIT);
		glColor4f(1,1,1,clamp((ti - gamesettime)/5,0,1));
		glBindTexture(GL_TEXTURE_2D, texendseq);
		glBegin(GL_QUADS);
		glTexCoord2f(1,0);	glVertex2f( 1, 1);
		glTexCoord2f(0,0);	glVertex2f(-1, 1);
		glTexCoord2f(0,1);	glVertex2f(-1,-1);
		glTexCoord2f(1,1);	glVertex2f( 1,-1);
		glEnd();
		glPopAttrib();

		Mix_Volume(-1, (int)((1 - (ti - gamesettime)/5) * 128));
		Mix_Volume(engine_ch, (int)((1 - (ti - gamesettime)/5) * 32));
		Mix_VolumeMusic((int)((1 - (ti - gamesettime)/5) * 96));
	}

	// score
	glPushMatrix();
		glTranslatef(-1.f, .9f, 0);
		glScalef(0.2f, 0.1f, 1);
		glBegin(GL_QUADS);
		glTexCoord2f(01./8*2, 1./8*2);	glVertex2f(1, 1);
		glTexCoord2f(01./8*0, 1./8*2);	glVertex2f(0, 1);
		glTexCoord2f(01./8*0, 1./8*3);	glVertex2f(0, 0);
		glTexCoord2f(01./8*2, 1./8*3);	glVertex2f(1, 0);
		glEnd();
		{
			int i, m = 1000000;

			glTranslatef(.3f, -.7f, 0);
			glScalef(0.25f, 1, 1);
			for(i = 6; i >= 0; i--, m /= 10)
			{
				int n = (score / m % 10) + 4;
				glBegin(GL_QUADS);
				glTexCoord2f(1.f/16*(n+1), 1./8*2);	glVertex2f(1, 1);
				glTexCoord2f(1.f/16*(n  ), 1./8*2);	glVertex2f(0, 1);
				glTexCoord2f(1.f/16*(n  ), 1./8*3);	glVertex2f(0, 0);
				glTexCoord2f(1.f/16*(n+1), 1./8*3);	glVertex2f(1, 0);
				glEnd();
				glTranslatef(1, 0, 0);
			}
		}
	glPopMatrix();
skipgamehud:
	if(titling)
	{
		glBindTexture(GL_TEXTURE_2D, textitle);
		glBegin(GL_QUADS);
		glTexCoord2f(1,0);	glVertex2f( 1, 1);
		glTexCoord2f(0,0);	glVertex2f(-1, 1);
		glTexCoord2f(0,1);	glVertex2f(-1,-1);
		glTexCoord2f(1,1);	glVertex2f( 1,-1);
		glEnd();
	}

	glPopAttrib();

    SDL_GL_SwapBuffers( );
}

struct tagFlies *createNewFlyWithoutLink(OBJECT *obj, int type, int own)
{
	struct tagFlies *fly;

	if(!(fly = malloc(sizeof(*fly))))
		return NULL;

	fly->pos[0] = 0.0f;
	fly->pos[1] = 0.0f;
	fly->pos[2] = 0.0f;
	//fly->prepos[0] = fly->pos[0];
	//fly->prepos[1] = fly->pos[1];
	//fly->prepos[2] = fly->pos[2];
	fly->vel[0] = 0.0f;
	fly->vel[1] = 0.0f;
	fly->vel[2] = 0.0f;
	fly->acc[0] = 0.0f;
	fly->acc[1] = 0.0f;
	fly->acc[2] = 0.0f;
	fly->rot[0] = 0.0f;
	fly->rot[1] = 0.0f;
	fly->rot[2] = 0.0f;

	fly->obj = obj;
	fly->type = type;
	fly->owner = own;
	fly->borntime = gettime();
	fly->userf = 0.0f;
	fly->target = NULL;
	fly->targetfired = 0;
	fly->firedmissile = 0;
	fly->lifespan = 0;
	fly->next = NULL;

	return fly;
}

struct tagFlies *createNewFly(OBJECT *obj, int type, int own)
{
	struct tagFlies *fly;

	if(!(fly = createNewFlyWithoutLink(obj, type, own)))
		return NULL;

	fly->next = flyRoot;

	flyRoot = fly;

	return fly;
}

/*
struct tagFlies *createNewFlyToLast(OBJECT *obj, int type, int own)
{
	struct tagFlies *fly, *nfly;

	if(!(fly = createNewFlyWithoutLink(obj, type, own)))
		return NULL;

	for(nfly = flyRoot; nfly; nfly = nfly->next)
		if(nfly->next == NULL)
			break;

	if(nfly)
		nfly->next = fly;

	return fly;
}
*/

void terragen(int off);

void mkterrain(int offs)
{
	struct tagFlies *nfly = createNewFly(NULL, TYPE_TERRAIN, OWN_NONE);

	terragen(offs);

	nfly->pos[0] = rnd(1000.f) - 500.f;
	nfly->pos[2] = -1000 - rnd(500.f) - TERRAW/2.f*TERRAZ - (-flyPlayer.pos[2]);
	nfly->vel[2] = 0;//12.4f;
	nfly->toffs = offs;

	/*
	{
		char ts[256];
		sprintf(ts, "%.2f %.2f\n", nfly->pos[2], flyPlayer.pos[2]);
		OutputDebugString(ts);
	}
	*/
}

void flyAdvance(struct tagFlies *fly)
{
	//fly->prepos[0] = fly->pos[0];
	//fly->prepos[1] = fly->pos[1];
	//fly->prepos[2] = fly->pos[2];

	fly->pos[0] += fly->vel[0];// * framedelta;
	fly->pos[1] += fly->vel[1];// * framedelta;
	fly->pos[2] += fly->vel[2];// * framedelta;

	fly->vel[0] += fly->acc[0];// * framedelta;
	fly->vel[1] += fly->acc[1];// * framedelta;
	fly->vel[2] += fly->acc[2];// * framedelta;
}

void process_flies()
{
	struct tagFlies *fly, **pfly;
	float ti = gettime();

	for(fly = flyRoot, pfly = &flyRoot; fly; )
	{
		// erasing over world
		if(fly != &flyPlayer &&
			(fly->type != TYPE_TERRAIN && (
			(fly->pos[2]-(flyPlayer.pos[2]) < -1000 && fly->vel[2]-flyPlayer.vel[2] < 0)
			|| (fly->pos[2]-(flyPlayer.pos[2]) > TERRAW/2*TERRAZ && fly->vel[2]-flyPlayer.vel[2] >= 0))
			)
			||
			(fly->type == TYPE_TERRAIN &&
			(fly->pos[2]-(flyPlayer.pos[2]) > TERRAW/2*TERRAZ)
			)
			)
		{
			*pfly = fly->next;

			if(fly->type == TYPE_TERRAIN)
			{
				mkterrain(fly->toffs);

				free(fly);

				//// replay from first!
				//fly = flyRoot;
				//pfly = &flyRoot;
				fly = *pfly;

				continue;
			}

			{
				int i;
				for(i = 0; i < MAXLOCKON; i++)
				{
					if(flyLocked[i] == fly)
					{
						flyLocked[i] = NULL;
						break;
					}
				}
			}

			{
				struct tagFlies *f;

				for(f = 0; f; f = f->next)
				{
					if(f->target == fly)
						f->target = NULL;
				}
			}

			free(fly);

			fly = *pfly;

			continue;
		}

		// movement
		flyAdvance(fly);

		// type-independent procedures

		if(fly == &flyPlayer)
		{
			if(fly->userf < fly->userf2)
				fly->userf += 0.05f;
			if(fly->userf > fly->userf2)
				fly->userf -= 0.05f;
		}

		if(fly->type == TYPE_MISSILE)
		{
			int bombok = 0;
			//float /*z[3], */vr[3];

			/*
			getAxis(fly->rot, NULL, NULL, z);
			fly->vel[0] += -z[0] * 0.01f;
			fly->vel[1] += -z[1] * 0.01f;
			fly->vel[2] += -z[2] * 0.01f;
			*/
			/*
			getRot(fly->vel, vr);
			vr[0] = (vr[0] + fly->rot[0]) / 2;
			vr[1] = (vr[1] + fly->rot[1]) / 2;
			vr[2] += 0.1f / framedelta;
			getAxis(vr, NULL, NULL, fly->vel);
			fly->vel[0] *= -1;
			fly->vel[1] *= -1;
			fly->vel[2] *= -1;
			*/

			// rotation routine below.(out-of-if)

			if(fly->target)
			{
				REAL v[3], r1[3], r2[3];
				REAL n;
				REAL d;
				n = norm(fly->vel);

				//getRot(fly->vel, r1);
				v[0] = fly->pos[0] - fly->target->pos[0];
				v[1] = fly->pos[1] - fly->target->pos[1];
				v[2] = fly->pos[2] - fly->target->pos[2];
				//*
				getRot(v, r2);
				r1[0] = r2[0];//(r1[0]*2+r2[0])/3;
				r1[1] = r2[1];//(r1[1]*2+r2[1])/3;
				getAxis(r1, NULL, NULL, fly->vel);
				//*/
				/*
				fly->vel[0] = (fly->vel[0] * 239 + v[0]) / 240;
				fly->vel[1] = (fly->vel[1] * 239 + v[1]) / 240;
				fly->vel[2] = (fly->vel[2] * 239 + v[2]) / 240;
				normalize(fly->vel);
				*/
				if(fly->owner == OWN_ENEMY)
					n = clamp(n, 0, 5);
				fly->vel[0] *= (n + .1f);
				fly->vel[1] *= (n + .1f);
				fly->vel[2] *= (n + .1f);

				d = distance(fly->target->pos, fly->pos);
				if(fly->userf2 < d && d < n+.1f)
				{
					//_asm int 3;
					/*
					normalize(fly->vel);
					fly->vel[0] *= d/2;
					fly->vel[1] *= d/2;
					fly->vel[2] *= d/2;
					*/
					bombok = 1;
				}
				fly->userf2 = d;
			}

			if(fly->userf + 0.01 < ti)
			{
				struct tagFlies *f;

				fly->userf = ti;
				
				f = createNewFly(NULL, TYPE_SMOKE, OWN_NONE);
				f->pos[0] = fly->pos[0];
				f->pos[1] = fly->pos[1];
				f->pos[2] = fly->pos[2];
				f->lifespan = 1.0f;
				//f->vel[2] = fly->vel[2] * 0.98f;
			}

			{
				struct tagFlies *f, **pf;

				for(f = flyRoot,pf=&flyRoot; f; pf=&f->next,f = f->next)
				{
					if(f->type == TYPE_FIGHTER && ((f->owner != fly->owner && distance(fly->pos, f->pos) < 1.0f) || (f == fly->target && bombok)))
					{
						struct tagFlies *nf;
						int i;

						// cutout victim
						if(f != &flyPlayer)
							*pf = f->next;

						for(i = 0; i < MAXLOCKON; i++)
						{
							if(flyLocked[i] == f)
							{
								flyLocked[i] = NULL;
								break;
							}
						}

						Mix_SetDistance(Mix_PlayChannel(-1, sndbomb, 0), (Uint8)clamp(distance(fly->pos, f->pos), 0, 255));

						if(f != &flyPlayer)
						{
							score += (int)(50 - clamp(distance(flyPlayer.pos, f->pos)*2, 0, 50) + 50) * 10;
						}

						nf = createNewFly(NULL, TYPE_BOMBFLASH, OWN_NONE);
						nf->pos[0] = f->pos[0];
						nf->pos[1] = f->pos[1];
						nf->pos[2] = f->pos[2];
						nf->lifespan = 2.0f;
						for(i = 0; i < 7; i++)
						{
							REAL r[3];
							struct tagFlies *nf;

							nf = createNewFlyWithoutLink(NULL, TYPE_BOMBSTUFF, OWN_NONE);
							nf->pos[0] = f->pos[0];
							nf->pos[1] = f->pos[1];
							nf->pos[2] = f->pos[2];
							r[0] = rnd(90) - 90 - 30;
							r[1] = rnd(360) - 180;
							getAxis(r, NULL, nf->vel, NULL);
							nf->vel[0] *= 4.0f;
							nf->vel[1] *= 4.0f;
							nf->vel[2] *= 4.0f;
							//nf->vel[1] = .3f;
							nf->acc[1] = -.4f;
							nf->userf = 0;
							nf->userf2 = 10.0f;
							nf->lifespan = 1.0f;

							for(; nf->userf2 > 0; )
							{
								struct tagFlies *f;

								//fly->userf = ti;
								flyAdvance(nf);
								
								f = createNewFly(NULL, TYPE_BOMBSMOKE, OWN_NONE);
								f->pos[0] = nf->pos[0];
								f->pos[1] = nf->pos[1];
								f->pos[2] = nf->pos[2];
								//f->vel[2] = fly->vel[2] * 0.98f;
								f->userf = nf->userf2;
								f->lifespan = 2.0f;

								nf->userf2 -= 1.4f;
							}
							free(nf);
						}

						if(f != &flyPlayer)
							free(f);

						// cutout missile
						*pfly = fly->next;
						free(fly);

						fly = *pfly;

						break;
					}
				}
			}
		}
		if(fly->type == TYPE_BOMBSTUFF)
		{
			if(fly->userf + 0.01 < ti && fly->userf2 > 0)
			{
				struct tagFlies *f;

				fly->userf = ti;
				
				f = createNewFly(NULL, TYPE_BOMBSMOKE, OWN_NONE);
				f->pos[0] = fly->pos[0];
				f->pos[1] = fly->pos[1];
				f->pos[2] = fly->pos[2];
				//f->vel[2] = fly->vel[2] * 0.98f;
				f->userf = fly->userf2;
				f->lifespan = 2.0f;

				fly->userf2 -= .7f;
			}
		}
		//if(fly->type == TYPE_SMOKE || fly->type == TYPE_BOMBFLASH || fly->type == TYPE_BOMBSTUFF || fly->type == TYPE_BOMBSMOKE || fly->type == TYPE_ABSHOCK)
		if(fly->lifespan > 0 && fly->borntime + fly->lifespan < ti)
		{
			//if(fly->borntime + (fly->type == TYPE_BOMBSMOKE ? 2.0f : 1.0f) < ti)
			{
				*pfly = fly->next;

				free(fly);

				fly = *pfly;
				continue;
				/*
				// replay from first!
				fly = flyRoot;
				pfly = &flyRoot;
				*/
			}
		}
		if((fly->type == TYPE_FIGHTER && fly->owner == OWN_ENEMY) || fly->type == TYPE_MISSILE)
		{
			//float rot[3];

			getRot(fly->vel, fly->rot);
			fly->rot[1] *= 2;
			fly->rot[2] = 0;
			/*
			if(fly->type == TYPE_MISSILE)
			{
				char ts[256];
				sprintf(ts, "%f,%f,%f -> %f,%f,%f\n", fly->vel[0],fly->vel[1],fly->vel[2],fly->rot[0], fly->rot[1], fly->rot[2]);
				OutputDebugString(ts);
			}
			*/
		}
		if(fly->type == TYPE_FIGHTER && fly->owner == OWN_ENEMY && fly->firemissilez > 0 && flyPlayer.pos[0] > fly->orgz + fly->firemissilez && !fly->firedmissile)
		{
			struct tagFlies *missile;
			REAL z[3];

			Mix_PlayChannel(-1, sndmissile, 0);

			missile = createNewFly(objmissile, TYPE_MISSILE, OWN_ENEMY);
			missile->pos[0] = fly->pos[0] + rside * 0.7f;
			rside = -rside;
			missile->pos[1] = fly->pos[1];
			missile->pos[2] = fly->pos[2];
			getAxis(fly->rot, NULL, NULL, z);
			missile->vel[0] = -z[0] * 0.0f;// + fly->vel[0];//(flyPlayer.pos[0] - flyPlayer.prepos[0]);
			missile->vel[1] = -z[1] * 0.0f;// + fly->vel[1];//(flyPlayer.pos[1] - flyPlayer.prepos[1]);
			missile->vel[2] = -z[2] * 0.0f;// + fly->vel[2];
			missile->acc[2] = .07f;//-0.0011f / 10.0f /framedelta/framedelta;
			missile->rot[0] = fly->rot[0];
			missile->rot[1] = fly->rot[1];
			missile->rot[2] = fly->rot[2];

			missile->target = &flyPlayer;
			missile->userf2 = distance(missile->target->pos, missile->pos) + 5;	// first frame will short

			fly->firedmissile = 1;
		}

		pfly = &fly->next;
		fly = fly->next;
	}
}

void initgame();

int process_keymouse()
{
	float ti = gettime();
	float delta = 1.0f;

	if(kstate[SDLK_ESCAPE])
		return 1;
	//if(kstate[SDLK_q])
	//	return 1;
	if(titling)
	{
		if(kstate[SDLK_SPACE])
		{
			titling = 0;
			initgame();
		}
		return 0;
	}

	if(kstate[SDLK_BACKSPACE] == 1)
	{
		initgame();
	}

	if(gameset && (ti - gamesettime) > 5)
		return 0;

	/*
	if(kstate[SDLK_LSHIFT])
		delta *= -1.0f;

	if( mstate[SDL_BUTTON_LEFT] && !kstate[SDLK_LSHIFT] && !kstate[SDLK_LCTRL])	angle = (float)fmod(angle - 1.0f, 360.0f);
	if(mstate[SDL_BUTTON_RIGHT] && !kstate[SDLK_LSHIFT] && !kstate[SDLK_LCTRL])	angle = (float)fmod(angle + 1.0f, 360.0f);
	if( mstate[SDL_BUTTON_LEFT] &&  kstate[SDLK_LSHIFT] && !kstate[SDLK_LCTRL])	anglet = (float)fmod(anglet - 1.0f, 360.0f);
	if(mstate[SDL_BUTTON_RIGHT] &&  kstate[SDLK_LSHIFT] && !kstate[SDLK_LCTRL])	anglet = (float)fmod(anglet + 1.0f, 360.0f);
	if( mstate[SDL_BUTTON_LEFT] &&                          kstate[SDLK_LCTRL])	angleu = (float)fmod(angleu - 1.0f, 360.0f);
	if(mstate[SDL_BUTTON_RIGHT] &&                          kstate[SDLK_LCTRL])	angleu = (float)fmod(angleu + 1.0f, 360.0f);

	if(kstate[SDLK_1] == 1)	curobj = objf15;
	if(kstate[SDLK_2] == 1)	curobj = objmig25;
	if(kstate[SDLK_3] == 1)	curobj = objf14;
	if(kstate[SDLK_4] == 1)	curobj = objmissile;
	if(kstate[SDLK_5] == 1)	curobj = objbullet;
	*/

	sx = clamp(sx*23/24 + dmx * 0.6f, -0.6f, 0.6f);
	sy = clamp(sy*23/24 + dmy * 0.4f, -0.4f, 0.4f);

	flyPlayer.rot[0] = sy * 50*2;
	flyPlayer.rot[1] = -sx * 50*2;
	flyPlayer.rot[2] = -sx * 50*2;//-a / 3.14159f * 180.0f;

	flyPlayer.vel[0] = -flyPlayer.rot[2] * 0.1f;// * 50;//-z[0] * 10.0f;
	flyPlayer.vel[1] =  flyPlayer.rot[0] * 0.1f;// * 50;//-z[1] * 5.0f;
	//flyPlayer.pos[2] += z[2];

	if(1 || !kstate[SDLK_LSHIFT])
	{
		flyPlayer.pos[0] = clamp(flyPlayer.pos[0], -490, 490);
		flyPlayer.pos[1] = clamp(flyPlayer.pos[1], 10, 100);
	}

	{
		int en;

		if((kstate[SDLK_w] && curengine != 2 && !boosted) || boosttime + 2.0f > ti)
		{
			flyPlayer.vel[2] = -12.4f;
			flyPlayer.userf2 = 1.0f;
			en = 2;
		}else if(kstate[SDLK_s])
		{
			flyPlayer.vel[2] = -6.3f;
			flyPlayer.userf2 = .3f;
			en = 0;
		}else
		{
			if(!kstate[SDLK_w])
				boosted = 0;
			flyPlayer.vel[2] = -9.7f;
			flyPlayer.userf2 = .5f;
			en = 1;
		}

		if(en != curengine)
		{
			Mix_HaltChannel(engine_ch);
			engine_ch = Mix_PlayChannel(-1, sndengines[en], -1);
			Mix_Volume(engine_ch, 32);

			curengine = en;

			if(curengine == 2)
			{
				struct tagFlies *shock;
				float v[3];

				shock = createNewFly(NULL, TYPE_ABSHOCK, OWN_NONE);
				getAxis(flyPlayer.rot, NULL, NULL, v);
				shock->pos[0] += flyPlayer.pos[0];
				shock->pos[1] += flyPlayer.pos[1];
				shock->pos[2] += flyPlayer.pos[2];
				shock->vel[0] = flyPlayer.vel[0] * 0.95f;
				shock->vel[1] = flyPlayer.vel[1] * 0.95f;
				shock->vel[2] = flyPlayer.vel[2] * 0.95f;
				shock->lifespan = .3f;

				buruburu = .02f;
				boosttime = ti;
				boosted = 1;
			}
		}
	}

	if(mstate[SDL_BUTTON_LEFT])
	{
		static Uint32 p;
		Uint32 t = SDL_GetTicks();

		if(p + 50 < t)
		{
			struct tagFlies *bullet;
			REAL z[3];

			p = t;
			Mix_PlayChannel(-1, sndshot, 0);

			bullet = createNewFly(objbullet, TYPE_BULLET, OWN_SELF);
			bullet->pos[0] = flyPlayer.pos[0];
			bullet->pos[1] = flyPlayer.pos[1];
			bullet->pos[2] = flyPlayer.pos[2];
			getAxis(flyPlayer.rot, NULL, NULL, z);
			bullet->vel[0] = -z[0] * 7.9f + flyPlayer.vel[0];//(flyPlayer.pos[0] - flyPlayer.prepos[0]);
			bullet->vel[1] = -z[1] * 7.9f + flyPlayer.vel[1];//(flyPlayer.pos[1] - flyPlayer.prepos[1]);
			bullet->vel[2] = -z[2] * 7.9f + flyPlayer.vel[2];
			//bullet->acc[1] = -0.0011f / 10.0f;
			bullet->rot[0] = flyPlayer.rot[0];
			bullet->rot[1] = flyPlayer.rot[1];
			bullet->rot[2] = flyPlayer.rot[2];
		}
	}
	if(mstate[SDL_BUTTON_RIGHT] == 1)
	{
		static Uint32 p;
		Uint32 t = SDL_GetTicks();

		if(p + 50 < t && stockedmissiles > 0)
		{
			struct tagFlies *missile;
			REAL z[3];

			p = t;
			Mix_PlayChannel(-1, sndmissile, 0);

			missile = createNewFly(objmissile, TYPE_MISSILE, OWN_SELF);
			missile->pos[0] = flyPlayer.pos[0] + rside * 0.7f;
			rside = -rside;
			missile->pos[1] = flyPlayer.pos[1];
			missile->pos[2] = flyPlayer.pos[2];
			getAxis(flyPlayer.rot, NULL, NULL, z);
			missile->vel[0] = -z[0] * 0.0f + flyPlayer.vel[0];//(flyPlayer.pos[0] - flyPlayer.prepos[0]);
			missile->vel[1] = -z[1] * 0.0f + flyPlayer.vel[1];//(flyPlayer.pos[1] - flyPlayer.prepos[1]);
			missile->vel[2] = -z[2] * 0.0f + flyPlayer.vel[2];
			missile->acc[2] = -.07f;//-0.0011f / 10.0f /framedelta/framedelta;
			missile->rot[0] = flyPlayer.rot[0];
			missile->rot[1] = flyPlayer.rot[1];
			missile->rot[2] = flyPlayer.rot[2];

			{
				int i;

				for(i = 0; i < MAXLOCKON; i++)
				{
					if(flyLocked[i] && !flyLocked[i]->targetfired)
					{
						flyLocked[i]->targetfired = 1;
						missile->target = flyLocked[i];
						missile->userf2 = distance(missile->target->pos, missile->pos) + 5;	// first frame will short
						break;
					}
				}
			}

			stockedmissiles--;
			lastshoot = ti;
		}
	}

	/*
	if(mstate[SDL_BUTTON_WHEELDOWN])
		flyPlayer.vel[2]--;
	if(mstate[SDL_BUTTON_WHEELUP])
		flyPlayer.vel[2]++;
	*/

	/*
	if(mstate[SDL_BUTTON_MIDDLE])
	{
		flyPlayer.pos[0] = mx * 5;
		flyPlayer.pos[1] = my * 5+3;
	}
	*/

	/*
	if(kstate[SDLK_SPACE] == 1)
	{
		struct tagFlies *f, **pf;

		for(pf=&flyRoot,f=flyRoot; f; )
		{
			if(f->type != TYPE_FIGHTER)
			{
				struct tagFlies *nf;
				nf = f->next;
				free(f);
				*pf = nf;
				f = nf;
				continue;
			}
			pf = &f->next;
			f = f->next;
		}

		{
			int i;

			for(i = 0; i < TERRAS; i++)
				mkterrain(i);
		}

		{
			int i;

			for(i = 0; i < MAXLOCKON; i++)
			{
				if(flyLocked[i])
					flyLocked[i]->targetfired = 0;
				flyLocked[i] = NULL;
			}
		}
	}
	*/

	// revive
	if(lastshoot + 0.5 < ti)
	{
		stockedmissiles = min(stockedmissiles + 1, 50);
		lastshoot = ti;
	}

	if(!gameset)
		score += -(int)(flyPlayer.vel[2] / 2);

	mx = clamp(mx + dmx, -1.0f, 1.0f);
	my = clamp(my + dmy, -1.0f, 1.0f);
	dmx = 0.0f;
	dmy = 0.0f;

	return 0;
}

void processInputEvent(SDL_Event *ev)
{
	switch(ev->type)
	{
	case SDL_KEYDOWN:
		kcurstate[ev->key.keysym.sym] = 1;
		kstate[ev->key.keysym.sym] = 1;
		break;
	case SDL_KEYUP:
		kcurstate[ev->key.keysym.sym] = 0;	// make next state 0
		break;
	case SDL_USEREVENT:	// frame event
		// these 2 button doesn't post button-up message, so reset every frame.
		mcurstate[SDL_BUTTON_WHEELUP] = 0;
		mcurstate[SDL_BUTTON_WHEELDOWN] = 0;
		// update state
		{
			int i;

			for(i = 0; i < SDLK_LAST; i++)
				kstate[i] = kcurstate[i] ? 2 : 0;
			for(i = 0; i < MOUSE_BUTTONS; i++)
				mstate[i] = mcurstate[i] ? 2 : 0;
		}
		break;
	case SDL_MOUSEBUTTONDOWN:
		mstate[ev->button.button] = 1;
		mcurstate[ev->button.button] = 1;
		goto mmotion;
	case SDL_MOUSEBUTTONUP:
		mcurstate[ev->button.button] = 0;	// same as key
		goto mmotion;
mmotion:
	case SDL_MOUSEMOTION:
		// delta
		dmx +=  (ev->motion.x - WinW/2.0f) / (WinW/2.0f);
		dmy += -(ev->motion.y - WinH/2.0f) / (WinH/2.0f);
		// move cursor to center
		SDL_WarpMouse((Uint16)(WinW/2), (Uint16)(WinH/2));
		break;
	}
}

int process_enemyspawn()
{
	//float t = gettime() - begintime;

	while(eneCurr && eneCurr->zpoint < -flyPlayer.pos[2])
	{
		struct tagFlies *fly;
		OBJECT *obj = objmissile;	// dummy model

		if(eneCurr->firemissilez < 0)
			return 1;

		switch(eneCurr->ftype)
		{
		case FIGHTER_F14:	obj = objf14;	break;
		case FIGHTER_F15:	obj = objf15;	break;
		case FIGHTER_MIG25:	obj = objmig25;	break;
		case 0:	obj=objmissile;break;
		}
		fly = createNewFly(obj, TYPE_FIGHTER, OWN_ENEMY);
		fly->pos[0] = eneCurr->pos[0] + flyPlayer.pos[0];
		fly->pos[1] = eneCurr->pos[1] + flyPlayer.pos[1];
		fly->pos[2] = eneCurr->pos[2] + flyPlayer.pos[2];
		fly->vel[0] = eneCurr->vel[0];
		fly->vel[1] = eneCurr->vel[1];
		fly->vel[2] = eneCurr->vel[2];
		fly->acc[0] = eneCurr->acc[0];
		fly->acc[1] = eneCurr->acc[1];
		fly->acc[2] = eneCurr->acc[2];
		fly->orgz = flyPlayer.pos[2];
		fly->firemissilez = eneCurr->firemissilez;

		// left4debug
		if(eneCurr->ftype == 0)
		{
			fly->type = TYPE_MISSILE;
			fly->target = &flyPlayer;
		}

		eneCurr = eneCurr->next;
	}

	return 0;
}

int penddraw = 0;

int process_frame()
{
	static float framepretime;
	float frametime;

	frametime = gettime(); 
	framedelta = frametime - framepretime;
	framepretime = frametime;

	if(process_keymouse())
		return 1;	// Quit key pressed
	if(!titling)
	{
		if(!gameset && process_enemyspawn())
		{
			gameset = 1;
			gamesettime = gettime();
		}
		process_flies();
	}
	draw();
	{
		int s = (int)gettime();

		curfps++;
		if(s != fpssec)
		{
			char ts[256];
			fpssec = s;
			prefps = curfps;
			curfps = 0;
			sprintf(ts, "%d fps", prefps);
			SDL_WM_SetCaption(ts, NULL);
		}
	}
	penddraw = 0;

	return 0;
}

void setupGL(void);

int process()
{
	SDL_Event event;

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
			/*
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
				SDL_Quit();
				exit(0);
				break;
			case SDLK_SPACE:
				rot = !rot;
				break;
			}
			break;
			*/
		case SDL_QUIT:
			SDL_Quit();
			exit(0);
			break;
		case SDL_USEREVENT:
			if(process_frame())
				return 1;
			break;
		case SDL_VIDEORESIZE:
			WinW = event.resize.w;
			WinH = event.resize.h;
			setupGL();
			break;
		default:
			break;
		}
		processInputEvent(&event);
	}

	//if(process_frame())
	//	return 1;

	return 0;
}

Uint32 frameTimer(Uint32 intv, void *param)
{
	SDL_Event ev;

	ev.type = SDL_USEREVENT;	// USEREVENT means RefreshWindow
	ev.user.type = SDL_USEREVENT;
	ev.user.code = 0;
	ev.user.data1 = NULL;
	ev.user.data2 = NULL;

	if(!penddraw)	// if already drew
	{
		SDL_PushEvent(&ev);	// request refreshwindow.
		penddraw = 1;
	}

	return intv;
}

BYTE *unzReadWhole(unzFile *zip, const char *fname, long *size)
{
	BYTE *buf;
	long s;
#ifdef ZIPFS
	unz_file_info info;

	if(unzLocateFile(zip, fname, 0) != UNZ_OK)
		return NULL;

	unzGetCurrentFileInfo(zip, &info, NULL, 0, NULL, 0, NULL, 0);
	s = info.uncompressed_size;
	buf = malloc(s + 1);
	if(size)
		*size = s;
	unzOpenCurrentFile(zip);
	unzReadCurrentFile(zip, buf, s);
	buf[s] = '\0';
	unzCloseCurrentFile(zip);
#else
	FILE *fp;
	if(!(fp = fopen(fname, "rb")))
		return NULL;
	fseek(fp, 0, SEEK_END);
	s = ftell(fp);
	if(size)
		*size = s;
	buf = malloc(s + 1);
	fseek(fp, 0, SEEK_SET);
	fread(buf, s, 1, fp);
	buf[s] = '\0';
	fclose(fp);
#endif

	return buf;
}

OBJECT *load3dsfromzip(unzFile *zip, const char *fname)
{
	OBJECT *obj;
	BYTE *buf;
	long size;

	if(!(buf = unzReadWhole(zip, fname, &size)))
		return NULL;

	obj = load3dsfrommem(buf, size);

	free(buf);

	return obj;
}

Mix_Chunk *Mix_LoadWAVfromzip(unzFile *zip, const char *fname)
{
	Mix_Chunk *wav;
	BYTE *buf;
	long size;

	if(!(buf = unzReadWhole(zip, fname, &size)))
		return NULL;

	wav = Mix_LoadWAV_RW(SDL_RWFromMem(buf, size), 1);

	free(buf);

	return wav;
}

Mix_Music *Mix_LoadMUSfromzip(unzFile *zip, const char *fname)
{
	Mix_Music *mus;
	SDL_RWops *op;
	BYTE *buf;
	long size;

	if(!(buf = unzReadWhole(zip, fname, &size)))
		return NULL;

	mus = Mix_LoadMUS_RW(op = SDL_RWFromMem(buf, size));

	// Music uses RWops while playing!!
	//SDL_FreeRW(op);
	//free(buf);

	return mus;
}

unsigned int pngBindfromzip(unzFile *zip, const char *fname, int mipmap, int trans, pngInfo *info, int wrapst, int minfilter, int magfilter)
{
	unsigned int ret;
	BYTE *buf;

	if(!(buf = unzReadWhole(zip, fname, NULL)))
	{
		MessageBox(NULL, "Corrupted EXE file, re-download please!\n\nInternal error: file not found.", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}

	ret = pngBindX(buf, mipmap, trans, info, wrapst, minfilter, magfilter);

	free(buf);

	return ret;
}

void loadres()
{
	unzFile *zip = NULL;

#ifdef ZIPFS
#ifdef ZIPRESOURCE
	if(!(zip = unzOpen2("DATAZIP", getResFileFuncDef())))
	{
		MessageBox(NULL, "Corrupted EXE file, re-download please!\n\nInternal error: resource not found.", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}
#else
	if(!(zip = unzOpen("data.zip")))
	{
		MessageBox(NULL, "Corrupted EXE file, re-download please!\n\nInternal error: resource not found.", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}
#endif
#else
	SetCurrentDirectory("data");
#endif

	objf15		= load3dsfromzip(zip, "fighter.3ds");
	objf15->file = "F15";
	objmig25	= load3dsfromzip(zip, "mig25.3ds");
	objmig25->file = "MiG25";
	objf14		= load3dsfromzip(zip, "f14tomcat.3ds");
	objf14->file = "F14tomcat";
	objmissile	= load3dsfromzip(zip, "missile.3ds");
	objmissile->file = "missile";
	objbullet	= load3dsfromzip(zip, "bulletfire.3ds");
	objbullet->file = "bullet";

	sndshot			= Mix_LoadWAVfromzip(zip, "shot.wav");
	sndengines[0]	= Mix_LoadWAVfromzip(zip, "ef20003m_4.wav");
	sndengines[1]	= Mix_LoadWAVfromzip(zip, "ef20003m_2.wav");
	sndengines[2]	= Mix_LoadWAVfromzip(zip, "ef20003m_3.wav");
	sndmissile		= Mix_LoadWAVfromzip(zip, "missile.wav");
	sndlockon		= Mix_LoadWAVfromzip(zip, "lockon16.wav");
	sndbomb			= Mix_LoadWAVfromzip(zip, "bomb1.wav");

	bgm1 = Mix_LoadMUSfromzip(zip, "final_base.ogg");

	texjet		= pngBindfromzip(zip, "jet.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texjetf		= pngBindfromzip(zip, "jetfrom.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texjetf2	= pngBindfromzip(zip, "jetf2.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsea		= pngBindfromzip(zip, "umi.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_REPEAT, GL_LINEAR, GL_LINEAR);
	texsky		= pngBindfromzip(zip, "sky.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP_TO_EDGE, GL_LINEAR, GL_LINEAR);
	texlock1	= pngBindfromzip(zip, "lock1.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texlock2	= pngBindfromzip(zip, "lock2.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texlock3	= pngBindfromzip(zip, "lock3.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsight	= pngBindfromzip(zip, "sight.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texlandmap	= pngBindfromzip(zip, "landmap.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_REPEAT, GL_NEAREST, GL_NEAREST);
	texsplash	= pngBindfromzip(zip, "splash3.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsplashw1	= pngBindfromzip(zip, "splashwake1.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsplashw2	= pngBindfromzip(zip, "splashwake3.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsmoke	= pngBindfromzip(zip, "smokesprites0199.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texsun		= pngBindfromzip(zip, "sun.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texbsmoke	= pngBindfromzip(zip, "smokesprites0199_inv.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texburn		= pngBindfromzip(zip, "smokesprites0199_burn.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texabshock	= pngBindfromzip(zip, "abshock.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texhud		= pngBindfromzip(zip, "hud.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	textitle	= pngBindfromzip(zip, "title.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);
	texendseq	= pngBindfromzip(zip, "endofseq.png", PNG_NOMIPMAP, PNG_ALPHA, NULL, GL_CLAMP, GL_NEAREST, GL_NEAREST);

	{
		char *sttxt, *p, *q;
		struct tagEnemies *en, **pen = &eneRoot[0];

		sttxt = unzReadWhole(zip, "stage1.txt", NULL);
		for(p = sttxt; *p; p = q)
		{
			for(q = p; *q && *q != 0x0d && *q != 0x0a; q++)
				;	//
			while(*q && (*q == 0x0d || *q == 0x0a))
				*(q++) = '\0';

			en = malloc(sizeof(*en));

			en->next = NULL;
			*pen = en;

			// now p is chomp-ed line.
			en->zpoint       = (float)strtod(strtok(p, " "), NULL);
			en->firemissilez = (float)strtod(strtok(NULL, " "), NULL);
			if(en->firemissilez == -1)	// endoflist.
				break;
			en->pos[0]       = (float)strtod(strtok(NULL, " "), NULL);
			en->pos[1]       = (float)strtod(strtok(NULL, " "), NULL);
			en->pos[2]       = (float)strtod(strtok(NULL, " "), NULL);
			en->vel[0]       = (float)strtod(strtok(NULL, " "), NULL);
			en->vel[1]       = (float)strtod(strtok(NULL, " "), NULL);
			en->vel[2]       = (float)strtod(strtok(NULL, " "), NULL);
			en->acc[0]       = (float)strtod(strtok(NULL, " "), NULL);
			en->acc[1]       = (float)strtod(strtok(NULL, " "), NULL);
			en->acc[2]       = (float)strtod(strtok(NULL, " "), NULL);
			en->ftype        = strtol(strtok(NULL, " "), NULL, 10);

			pen = &en->next;
		}

		free(sttxt);
	}

#ifdef ZIPFS
	unzClose(zip);
#endif
}

void initgame()
{
	int i;

	flyPlayer.pos[0] = 0;
	flyPlayer.pos[1] = 3.7f;
	flyPlayer.pos[2] = -7.0f;

	flyPlayer.vel[0] = 0;
	flyPlayer.vel[1] = 0;
	flyPlayer.vel[2] = -6.3f;//-9.7f;//-12.4f;

	flyPlayer.acc[0] = 0;
	flyPlayer.acc[1] = 0;
	flyPlayer.acc[2] = 0;

	flyPlayer.obj = objf14;

	flyPlayer.type = TYPE_FIGHTER;
	flyPlayer.owner = OWN_SELF;
	flyPlayer.target = NULL;

	flyPlayer.userf = 0.5f;
	//flyPlayer.userf2 = 0;
	boosted = 0;
	boosttime = -100;

	flyPlayer.next = NULL;

	Mix_VolumeMusic(96);
	//Mix_FadeInMusic(mm, -1, 5000);
	Mix_PlayMusic(bgm1, -1);
	// Mix_HaltMusic();
	// Mix_FreeMusic(bgm1);

	Mix_HaltChannel(-1);
	Mix_Volume(-1, 128);
	engine_ch = Mix_PlayChannel(-1, sndengines[1], -1);
	Mix_Volume(engine_ch, 32);
	curengine = 1;
	stockedmissiles = 50;

	score = 0;
	gameset = 0;

	for(i = 0; i < TERRAS; i++)
		mkterrain(i);
	for(i = 0; i < MAXLOCKON; i++)
		flyLocked[i] = NULL;

	eneCurr = eneRoot[0];

	begintime = gettime();
}

void reterragen(int minx, int miny, int maxx, int maxy, int off)
{
	float mag = (maxx - minx) / (float)TERRAW;

	if(minx > maxx || miny > maxy)
		_asm int 3;

	if(miny==0 && 0)
		land[off][(minx+maxx)/2][miny] = clamp((land[off][minx][miny] + land[off][maxx][miny]) / 2 + rnd(mag*2.0f) - mag, -1, .90f);	// top
	if(minx==0 && 0)
		land[off][minx][(miny+maxy)/2] = clamp((land[off][minx][miny] + land[off][minx][maxy]) / 2 + rnd(mag*2.0f) - mag, -1, .90f);	// left
	if(maxx != TERRAW)
		land[off][maxx][(miny+maxy)/2] = clamp((land[off][maxx][miny] + land[off][maxx][maxy]) / 2 + rnd(mag*2.0f) - mag, -1, .90f);	// right
	if(maxy != TERRAW)
		land[off][(minx+maxx)/2][maxy] = clamp((land[off][minx][maxy] + land[off][maxx][maxy]) / 2 + rnd(mag*2.0f) - mag, -1, .90f);	// bottom
	land[off][(minx+maxx)/2][(miny+maxy)/2] = clamp(
		/*(land[minx][(miny+maxy)/2]
		+land[maxx][(miny+maxy)/2]
		+land[(minx+maxx)/2][miny]
		+land[(minx+maxx)/2][maxy]
		*/
		(land[off][minx][miny]
		+land[off][maxx][miny]
		+land[off][minx][maxy]
		+land[off][maxx][maxy]
		) / 4 + rnd(mag) - mag/2.0f, -1, .90f);	// center

	if(minx + 2 == maxx)
		return;

	reterragen(minx         , miny         , (minx+maxx)/2, (miny+maxy)/2, off);	// left-up
	reterragen((minx+maxx)/2, miny         , maxx         , (miny+maxy)/2, off);	// right-up
	reterragen(minx         , (miny+maxy)/2, (minx+maxx)/2, maxy         , off);	// left-down
	reterragen((minx+maxx)/2, (miny+maxy)/2, maxx         , maxy         , off);	// right-down
}

void terragen(int off)
{
	land[off][ 0][ 0] = 0.0f;
	land[off][TERRAW][ 0] = 0.0f;
	land[off][ 0][TERRAW] = 0.0f;
	land[off][TERRAW][TERRAW] = 0.0f;

	{
		int i,j;

		for(i=0;i<=TERRAW;i++)
			for(j=0;j<=TERRAW;j++)
				land[off][i][j]=-.01f;

		for(i = 0; i <= TERRAW; i++)
		{
			land[off][ i][ 0] = -.01f;
			land[off][ 0][ i] = -.01f;
			land[off][ i][TERRAW] = -.01f;
			land[off][TERRAW][ i] = -.01f;
		}
	}

	reterragen(0, 0, TERRAW, TERRAW, off);

	/*
	if(0)
	{
		int x, y;

		for(y = 0; y < 257; y++)
		{
			for(x = 0; x < 257; x++)
				printf("%.2f,", land[x][y]);
			printf("\n");
		}
	}
	*/
}

void setupGL(void)
{
	if(!SDL_SetVideoMode(WinW, WinH, 32, SDL_OPENGL | SDL_RESIZABLE | (SDL_FULLSCREEN * isFullscr)))
	{
		MessageBox(NULL, "SDL SetVideoMode failed!", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}

	glShadeModel(GL_SMOOTH);
	glCullFace(GL_BACK);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);

	glClearColor(0, 0, 0, 0);

	glViewport(0, 0, WinW, WinH);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

    glMatrixMode( GL_MODELVIEW );

	glEnable(GL_LIGHTING);
	glEnable(GL_BLEND);
}

int main( int argc, char* argv[] )
{
	srand(time(NULL));

	if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER) < 0)
	{
		MessageBox(NULL, "SDL Initialization failed!", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}

	Mix_OpenAudio(22050, 8, 1, 1024);
	Mix_AllocateChannels(64);

	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	WinW = 800;
	WinH = 600;

	isFullscr = (MessageBox(NULL, "Fullscreen?", "Question", MB_ICONQUESTION | MB_YESNO) == IDYES);

	setupGL();

	if(!SDL_AddTimer(1000/60, frameTimer, NULL))	// begin request refresh timer
	{
		MessageBox(NULL, "SDL Timer set failed!", "Fatal", MB_ICONERROR | MB_OK);
		exit(0);
	}

	SDL_WM_SetCaption("ake09", NULL);
	SDL_ShowCursor(SDL_FALSE);

	loadres();
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_ONE, GL_ONE);

	//initgame();

	while(1)
	{
		if(process())
			break;
		//SDL_Delay(1);
		//draw();
	}

	Mix_CloseAudio();

	SDL_Quit();
	return 0;
}
